#pragma once

#include <J3ML/LinearAlgebra/Vector3.hpp>
#include <J3ML/LinearAlgebra/Quaternion.hpp>
#include <J3ML/LinearAlgebra/AxisAngle.hpp>

namespace J3ML::LinearAlgebra {
    class EulerAngleXYZ;
}

class J3ML::LinearAlgebra::EulerAngleXYZ {
public:
public:
    float roll = 0; // X
    float pitch = 0; // Y
    float yaw = 0; // Z
public:
    EulerAngleXYZ(float roll, float pitch, float yaw);
public:
    explicit EulerAngleXYZ(const Quaternion& rhs);
    explicit EulerAngleXYZ(const AxisAngle& rhs);
    explicit EulerAngleXYZ(const Matrix3x3& rhs);
};
