#include <J3ML/LinearAlgebra/DirectionVector.hpp>
#include <J3ML/LinearAlgebra/Matrix3x3.hpp>

DirectionVectorRH::DirectionVectorRH(const Vector3& rhs) {
    x = rhs.x;
    y = rhs.y;
    z = rhs.z;
}

DirectionVectorRH DirectionVectorRH::Forward(const Matrix3x3& rhs) {
    return DirectionVectorRH(rhs.Col(2));
}

DirectionVectorRH DirectionVectorRH::Backward(const Matrix3x3& rhs) {
    return DirectionVectorRH(-rhs.Col(2));
}

DirectionVectorRH DirectionVectorRH::Left(const Matrix3x3& rhs) {
    return DirectionVectorRH(-rhs.Col(0));
}

DirectionVectorRH DirectionVectorRH::Right(const Matrix3x3& rhs) {
    return DirectionVectorRH(rhs.Col(0));
}

DirectionVectorRH DirectionVectorRH::Up(const Matrix3x3 &rhs) {
    return DirectionVectorRH(rhs.Col(1));
}

DirectionVectorRH DirectionVectorRH::Down(const Matrix3x3& rhs) {
    return DirectionVectorRH(-rhs.Col(1));
}






