#include <jtest/jtest.hpp>
#include <jtest/Unit.hpp>

jtest::Unit AxisAngleUnit {"AxisAngle"};

namespace AxisAngleTests {
    inline void Define() {
        using namespace jtest;

        AxisAngleUnit += Test("From_Quaternion", [] {
            AxisAngle expected_result({0.3860166, 0.4380138, 0.8118714}, 0.6742209);
            Quaternion q(0.1276794, 0.1448781, 0.2685358, 0.9437144);

            AxisAngle from_quaternion(q);

            jtest::check(Math::EqualAbs(expected_result.axis.x, from_quaternion.axis.x, 1e-6f));
            jtest::check(Math::EqualAbs(expected_result.axis.y, from_quaternion.axis.y, 1e-6f));
            jtest::check(Math::EqualAbs(expected_result.axis.z, from_quaternion.axis.z, 1e-6f));
            jtest::check(Math::EqualAbs(expected_result.angle, from_quaternion.angle, 1e-6f));
        });
    }
    inline void Run() {
        AxisAngleUnit.RunAll();
    }
}