//
// Created by josh on 12/26/2023.
//

#include <jtest/jtest.hpp>
#include <jtest/Unit.hpp>

jtest::Unit EulerAngleUnit {"EulerAngle_XYZ"};

namespace EulerAngleTests {
    inline void Define() {
        using namespace jtest;

        EulerAngleUnit += Test("From_Quaternion", [] {
            EulerAngleXYZ expected_result(-170, 88, -160);
            Quaternion q(0.1840604, 0.6952024, 0.1819093, 0.6706149);

            EulerAngleXYZ from_quaternion(q);

            jtest::check(Math::EqualAbs(Math::Radians(expected_result.roll), Math::Radians(from_quaternion.roll), 1e-5f));
            jtest::check(Math::EqualAbs(Math::Radians(expected_result.pitch), Math::Radians(from_quaternion.pitch), 1e-5f));
            jtest::check(Math::EqualAbs(Math::Radians(expected_result.yaw), Math::Radians(from_quaternion.yaw), 1e-5f));
        });
    }
    inline void Run() {
        EulerAngleUnit.RunAll();
    }
}